--- busybox-0.60.5.orig/libbb/xfuncs.c	Sat Apr 13 16:44:42 2002
+++ busybox-0.60.5/libbb/xfuncs.c	Thu Oct  2 14:31:21 2003
@@ -29,7 +29,7 @@
 #ifndef DMALLOC
 extern void *xmalloc(size_t size)
 {
-	void *ptr = malloc(size);
+	void *ptr = malloc((!size) ? ++size : size);
 	if (ptr == NULL && size != 0)
 		error_msg_and_die(memory_exhausted);
 	return ptr;
@@ -37,7 +37,7 @@ extern void *xmalloc(size_t size)
 
 extern void *xrealloc(void *ptr, size_t size)
 {
-	ptr = realloc(ptr, size);
+	ptr = realloc(ptr, (!size) ? ++size : size);
 	if (ptr == NULL && size != 0)
 		error_msg_and_die(memory_exhausted);
 	return ptr;
@@ -45,7 +45,8 @@ extern void *xrealloc(void *ptr, size_t 
 
 extern void *xcalloc(size_t nmemb, size_t size)
 {
-	void *ptr = calloc(nmemb, size);
+	void *ptr = calloc((!nmemb) ? ++nmemb : nmemb, 
+					   (!size) ? ++size : size);
 	if (ptr == NULL && nmemb != 0 && size != 0)
 		error_msg_and_die(memory_exhausted);
 	return ptr;
